searchNodes=[{"doc":"Provides custom guards to avoid boilerplate code","ref":"Bottle.html","title":"Bottle","type":"module"},{"doc":"Calling use Bottle will import all the guards into your context","ref":"Bottle.html#__using__/1","title":"Bottle.__using__/1","type":"macro"},{"doc":"Provides custom guards for binaries","ref":"Bottle.Binary.html","title":"Bottle.Binary","type":"module"},{"doc":"Guard that passes for a binary shorter than max_length Examples iex&gt; is_binary_shorter_than ( &quot;foo&quot; , 200 ) true iex&gt; is_binary_shorter_than ( &quot;&quot; , 2 ) true iex&gt; is_binary_shorter_than ( &quot;foo&quot; , 2 ) false","ref":"Bottle.Binary.html#is_binary_shorter_than/2","title":"Bottle.Binary.is_binary_shorter_than/2","type":"macro"},{"doc":"Guard that passes for an empty binary Examples iex&gt; is_empty_binary ( &quot;&quot; ) true iex&gt; is_empty_binary ( &quot;foo&quot; ) false","ref":"Bottle.Binary.html#is_empty_binary/1","title":"Bottle.Binary.is_empty_binary/1","type":"macro"},{"doc":"Guard that passes for a non-empty binary Examples iex&gt; is_non_empty_binary ( &quot;false&quot; ) true iex&gt; is_non_empty_binary ( &quot;&quot; ) false","ref":"Bottle.Binary.html#is_non_empty_binary/1","title":"Bottle.Binary.is_non_empty_binary/1","type":"macro"},{"doc":"Guard that passes for a non-empty-binary shorter than max_length Examples iex&gt; is_non_empty_binary_shorter_than ( &quot;foo&quot; , 200 ) true iex&gt; is_non_empty_binary_shorter_than ( &quot;&quot; , 2 ) false iex&gt; is_non_empty_binary_shorter_than ( &quot;foo&quot; , 2 ) false","ref":"Bottle.Binary.html#is_non_empty_binary_shorter_than/2","title":"Bottle.Binary.is_non_empty_binary_shorter_than/2","type":"macro"},{"doc":"Provides custom guards for lists","ref":"Bottle.List.html","title":"Bottle.List","type":"module"},{"doc":"Guard that passes for an empty list Examples iex&gt; is_empty_list ( [ ] ) true iex&gt; is_empty_list ( [ :foo ] ) false","ref":"Bottle.List.html#is_empty_list/1","title":"Bottle.List.is_empty_list/1","type":"macro"},{"doc":"Guard that passes for a list of a specific length Examples iex&gt; is_list_with_length ( [ ] , 0 ) true iex&gt; is_list_with_length ( [ :foo ] , 1 ) true iex&gt; is_list_with_length ( [ :foo ] , 2 ) false","ref":"Bottle.List.html#is_list_with_length/2","title":"Bottle.List.is_list_with_length/2","type":"macro"},{"doc":"Guard that passes for a non empty list Examples iex&gt; is_non_empty_list ( [ :foo ] ) true iex&gt; is_non_empty_list ( [ ] ) false","ref":"Bottle.List.html#is_non_empty_list/1","title":"Bottle.List.is_non_empty_list/1","type":"macro"},{"doc":"Provides custom guards for maps","ref":"Bottle.Map.html","title":"Bottle.Map","type":"module"},{"doc":"Guard that passes for an empty map Examples iex&gt; is_empty_map ( %{ } ) true iex&gt; is_empty_map ( %{ &quot;foo&quot; =&gt; :bar } ) false iex&gt; is_empty_map ( %{ foo : &quot;bar&quot; } ) false","ref":"Bottle.Map.html#is_empty_map/1","title":"Bottle.Map.is_empty_map/1","type":"macro"},{"doc":"Guard that passes for an map containing at least 1 element ## Examples iex&gt; is_non_empty_map ( %{ &quot;foo&quot; =&gt; :bar } ) true iex&gt; is_non_empty_map ( %{ foo : &quot;bar&quot; } ) true iex&gt; is_non_empty_map ( %{ } ) false","ref":"Bottle.Map.html#is_non_empty_map/1","title":"Bottle.Map.is_non_empty_map/1","type":"macro"},{"doc":"Provides custom guards for numbers","ref":"Bottle.Number.html","title":"Bottle.Number","type":"module"},{"doc":"Guard that passes when a number is a non_neg_float Examples iex&gt; is_non_neg_float ( 1 ) false iex&gt; is_non_neg_float ( 1.1 ) true iex&gt; is_non_neg_float ( 0.0 ) true iex&gt; is_non_neg_float ( 0 ) false iex&gt; is_non_neg_float ( - 1 ) false iex&gt; is_non_neg_float ( - 1.1 ) false","ref":"Bottle.Number.html#is_non_neg_float/1","title":"Bottle.Number.is_non_neg_float/1","type":"macro"},{"doc":"Guard that passes when a number is a non_neg_integer Examples iex&gt; is_non_neg_integer ( 1 ) true iex&gt; is_non_neg_integer ( 1.1 ) false iex&gt; is_non_neg_integer ( 0 ) true iex&gt; is_non_neg_integer ( - 1 ) false","ref":"Bottle.Number.html#is_non_neg_integer/1","title":"Bottle.Number.is_non_neg_integer/1","type":"macro"},{"doc":"Guard that passes when a number is a non_neg_number Examples iex&gt; is_non_neg_number ( 1 ) true iex&gt; is_non_neg_number ( 1.1 ) true iex&gt; is_non_neg_number ( 0 ) true iex&gt; is_non_neg_number ( - 1 ) false","ref":"Bottle.Number.html#is_non_neg_number/1","title":"Bottle.Number.is_non_neg_number/1","type":"macro"},{"doc":"Guard that passes when for any float that is not 0.0 Examples iex&gt; is_non_zero_float ( 1.1 ) true iex&gt; is_non_zero_float ( - 1.1 ) true iex&gt; is_non_zero_float ( 0.0 ) false iex&gt; is_non_zero_float ( 0 ) false iex&gt; is_non_zero_float ( 1 ) false iex&gt; is_non_zero_float ( - 1 ) false","ref":"Bottle.Number.html#is_non_zero_float/1","title":"Bottle.Number.is_non_zero_float/1","type":"macro"},{"doc":"Guard that passes when for any positive float Examples iex&gt; is_pos_float ( 1.1 ) true iex&gt; is_pos_float ( - 1.1 ) false iex&gt; is_pos_float ( 0.0 ) false iex&gt; is_pos_float ( 0 ) false iex&gt; is_pos_float ( 1 ) false iex&gt; is_pos_float ( - 1 ) false","ref":"Bottle.Number.html#is_pos_float/1","title":"Bottle.Number.is_pos_float/1","type":"macro"},{"doc":"Guard that passes when a number is a pos_integer Examples iex&gt; is_pos_integer ( 1 ) true iex&gt; is_pos_integer ( 1.1 ) false iex&gt; is_pos_integer ( 0 ) false iex&gt; is_pos_integer ( - 1 ) false","ref":"Bottle.Number.html#is_pos_integer/1","title":"Bottle.Number.is_pos_integer/1","type":"macro"},{"doc":"Guard that passes when a number is a pos_number Examples iex&gt; is_pos_number ( 1 ) true iex&gt; is_pos_number ( 1.1 ) true iex&gt; is_pos_number ( 0 ) false iex&gt; is_pos_number ( - 1 ) false iex&gt; is_pos_number ( - 1.1 ) false","ref":"Bottle.Number.html#is_pos_number/1","title":"Bottle.Number.is_pos_number/1","type":"macro"},{"doc":"Guard that passes when a number is 0 (including float 0.0) Examples iex&gt; is_zero ( 0 ) true iex&gt; is_zero ( 0.0 ) true iex&gt; is_zero ( 1 ) false","ref":"Bottle.Number.html#is_zero/1","title":"Bottle.Number.is_zero/1","type":"macro"},{"doc":"Guard that passes when for 0.0 Examples iex&gt; is_zero_float ( 0.0 ) true iex&gt; is_zero_float ( 0 ) false iex&gt; is_zero_float ( 1 ) false iex&gt; is_zero_float ( 1.1 ) false iex&gt; is_zero_float ( - 1 ) false iex&gt; is_zero_float ( - 1.1 ) false","ref":"Bottle.Number.html#is_zero_float/1","title":"Bottle.Number.is_zero_float/1","type":"macro"},{"doc":"Bottle Bottle provides a set of custom guards which help reduce a lot of boilerplate coode. You can find the package in hex.pm and the documentation in hexdocs.pm .","ref":"readme.html","title":"Bottle","type":"extras"},{"doc":"The the package can be installed from Hex , by adding bottle to your list of dependencies in mix.exs : def deps do [ { :bottle , &quot;~&gt; 1.0&quot; } ] end","ref":"readme.html#installation","title":"Bottle - Installation","type":"extras"},{"doc":"Just put use Bottle on top of your module and get all the guards available in your scope: defmodule MyModule do use Bottle def what_is ( sub ) when is_empty_binary ( sub ) do :empty_binary end def what_is ( sub ) when is_non_empty_binary_shorter_than ( sub , 10 ) do :non_empty_binary_shorter_than_10_bytes end def what_is ( sub ) when is_non_empty_map ( sub ) do :non_empty_map end def what_is ( sub ) when is_empty_map ( sub ) do :empty_map end def what_is ( sub ) when is_zero ( sub ) do :zero_integer_or_float end def what_is ( sub ) when is_pos_number ( sub ) do :number_greater_than_0 end def what_is ( sub ) when is_non_neg_integer ( sub ) do :integer_equal_or_greater_than_0 end def what_is ( sub ) when is_non_zero_float ( sub ) do :non_zero_float end end You can also import the guards selectively using import , ie: import Bottle.Binary , only : [ is_empty_binary : 1 ]","ref":"readme.html#usage","title":"Bottle - Usage","type":"extras"},{"doc":"You can find the complete list of guards in the documentation: https://hexdocs.pm/bottle .","ref":"readme.html#documentation","title":"Bottle - Documentation","type":"extras"},{"doc":"Bottle is available under the BSD 3-Clause aka &quot;BSD New&quot; license","ref":"readme.html#license","title":"Bottle - License","type":"extras"}]